<template>
    <div class="autocomplete">
        <input v-model="name" class="form-control"
               placeholder="Search product" type="text"
               aria-label="Search Wikipedia" @keydown="searchProduct"
        >
        <div class="autocomplete-items">
            <div v-for="product in products" :key="product.id" @click="singleProduct(product)">
                <a href="javascript:void(0)">{{product.name}}</a>
            </div>
        </div>
    </div>
</template>

<script>
    import {EventBus} from "./event-bus";

    export default {
        data(){
            return{
                products:{},
                name:'',
            }
        },
        methods:{
            searchProduct(){
                if (this.name.length>0){
                    axios.get(`/product/search/${this.name}`).then((response)=>{
                        //alert(response.data);
                        this.products=response.data;
                    });
                }else{
                    this.products={};
                }
            },
            singleProduct(product){
                EventBus.$emit('singleProduct', product);
            }
        },
    }
</script>
<style scoped>
    .autocomplete {
        position: relative;
        display: inline-block;
        margin: 15px 40% 25px;
    }
    input {
        border: 1px solid transparent;
        background-color: #f1f1f1;
        padding: 10px;
        font-size: 16px;
    }

    input[type=text] {
        background-color: #f1f1f1;
        width: 100%;
    }
    .autocomplete-items {
        position: absolute;
        border: 1px solid #d4d4d4;
        border-bottom: none;
        border-top: none;
        z-index: 99;
        /*position the autocomplete items to be the same width as the container:*/
        top: 100%;
        left: 0;
        right: 0;
    }

    .autocomplete-items div {
        padding: 10px;
        cursor: pointer;
        background-color: #fff;
        border-bottom: 1px solid #d4d4d4;
    }

    /*when hovering an item:*/
    .autocomplete-items div:hover {
        background-color: #e9e9e9;
    }

    /*when navigating through the items using the arrow keys:*/
    .autocomplete-active {
        background-color: DodgerBlue !important;
        color: #ffffff;
    }
</style>
